#include "pch.h"

#include "FTNStruc.hpp"
#include "Links.h"


/*******
  CLink
 *******/


CLink::CLink() 
: name(),
  password(),
  activity(ACTIVITY_USUAL),
  bsoType(-1),
  sendPriority(0),
  receivePriority(0),
  groups(),
  allowAreaCreationFlag(),
  autoCreatedPathName(),
  defaultGroup(),
  autocreatedSendPriority(0),
  autocreatedReceivePriority(0),
  availAreasFileName(),
  robotName(),
  akaSpecified(false)
 {

	ourAddress      = g_vars.m_addrMain;
}


bool CLink::canAccessGroup(const tstring& groupName) const {
	VTString::const_iterator	it = groups.begin();
	while (it != groups.end()) {
		if (lstrcmpi((*it).c_str(), groupName.c_str() ) == 0) {
			return true;
		}
		it++;
	}

	return false;
}


bool CLink::removeGroup(const tstring& groupName) {
	VTString::iterator	it = groups.begin();
	while (it != groups.end()) {
		if (lstrcmpi((*it).c_str(), groupName.c_str() ) == 0) {
			groups.erase( it );
			return true;
		}
		it++;
	}

	return false;
}

